/* sf26r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

real sf26r_c(real *x)
{
    /* Initialized data */

    static real sys009 = .7853981f;
    static real sd2pi = .797884f;
    static real a[18] = { -1.7e-19f,1.222e-17f,-7.5885e-16f,4.125321e-14f,
            -1.943834e-12f,7.848696e-11f,-2.679253e-9f,7.608163e-8f,
            -1.761946e-6f,3.246032e-5f,-4.606261e-4f,.00481918f,-.03489376f,
            .1580671f,-.3700949f,.2651786f,-.008723442f,.3154559f };
    static real b[19] = { 0.f,3.9e-19f,-2.698e-17f,1.64349e-15f,
            -8.747341e-14f,4.02633e-12f,-1.583755e-10f,5.248794e-9f,
            -1.440723e-7f,3.206532e-6f,-5.632079e-5f,7.531135e-4f,
            -.007287962f,.04719668f,-.177302f,.2615673f,.1790343f,-.2744743f,
            -.06629222f };
    static real c__[18] = { 0.f,0.f,-1.1e-19f,5.5e-19f,-2.88e-18f,1.631e-17f,
            -1.0012e-16f,6.7481e-16f,-5.06903e-15f,4.326596e-14f,
            -4.045789e-13f,5.168262e-12f,-7.864091e-11f,1.630646e-9f,
            -5.170594e-8f,3.075184e-6f,-5.36522e-4f,1.99892f };
    static real d__[18] = { 0.f,-3e-20f,1.3e-19f,-6.2e-19f,3.11e-18f,
            -1.669e-17f,9.662e-17f,-6.0999e-16f,4.25523e-15f,-3.336328e-14f,
            3.006145e-13f,-3.206747e-12f,4.220121e-11f,-7.271915e-10f,
            1.797245e-8f,-7.414498e-7f,6.838519e-5f,-.0311117f };
    static real sys059 = 3.4e38f;
    static real sys015 = .6366197f;

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double log(doublereal), cos(doublereal), sin(doublereal),
            sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static real y, z__, q1, q2, q3, x1, x2, x3, x4, fx, vj0;

    y = abs(*x);
    z__ = y * .125f;
    if (z__ > 1.f) {
        goto L4;
    }
    if (z__ == 0.f) {
        goto L3;
    }
    x2 = z__ * 4.f * z__ - 2.f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
/* L1: */
        q3 = x2 * q2 - q1 + a[i__ - 1];
    }
    vj0 = (q3 - q1) * .5f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 19; ++i__) {
        q1 = q2;
        q2 = q3;
/* L2: */
        q3 = x2 * q2 - q1 + b[i__ - 1];
    }
    fx = (q3 - q1) * .5f;
    ret_val = sys015 * (real)log(y) * vj0 + fx;
    goto L7;
L3:
    ret_val = -sys059;
    goto L7;
L4:
    z__ = 1.f / z__;
    x2 = z__ * 4.f * z__ - 2.f;
    q3 = 0.f;
    q2 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
/* L5: */
        q3 = x2 * q2 - q1 + c__[i__ - 1];
    }
    x1 = (q3 - q1) * .5f;
    q2 = 0.f;
    q3 = 0.f;
    for (i__ = 1; i__ <= 18; ++i__) {
        q1 = q2;
        q2 = q3;
/* L6: */
        q3 = x2 * q2 - q1 + d__[i__ - 1];
    }
    fx = (q3 - q1) * z__ * .5f;
    x2 = (real)cos((real)(y - sys009));
    x3 = (real)sin((real)(y - sys009));
    x4 = sd2pi / (real)sqrt(y);
    ret_val = x4 * (fx * x2 + x1 * x3);
L7:
    return ret_val;
} /* sf26r_c */
